
Application: gvSIG desktop - gvSIG bugs #3806
Spatial join geoprocess results are not correct (points and polygons)
10/07/2015 11:44 AM - Mario Carrera

Status: Closed % Done: 0%
Priority: High Spent time: 0.00 hour
Assignee: Francisco Díaz Carsí
Category: Geoprocess
Target version: 2.4.0-2829 (rev. org.gvsig.desktop-2.0.195)
Severity: Major Add-on version:
gvSIG version: 2.2.0 Add-on build:
gvSIG build: 2313 Add-on resolve version:
Operative System: Add-on resolve build:
Keywords: Proyecto:
Has patch: Hito:
Add-on name: Unknown
Description

The results are not correct when using Spatial Join gvSIG geoprocess by nearest point.

I attach two layers: 
- cuencas_vert_MAGV.shp (polygons) 
- Entrada (points)

We select this configuration: 
- Input layer: cuencas_vert_MAGV.shp  
- Overlay layer: Entrada.shp 
- "Use the nearest" option

A lot of polygons are exported, not only the nearest one to every point.

Nota:
A la hora de probar este tique, no tener en cuenta esta descripción, sino los comentarios 12 y 13.

Related issues:
Related to Application: gvSIG desktop - gvSIG bugs # 3013: Error con la herra... Closed 11/19/2014
Related to Application: gvSIG desktop - gvSIG bugs # 3838: Random layers gene... Closed 10/28/2015
Related to Application: gvSIG desktop - gvSIG bugs # 3566: enlace espacial no... New 06/02/2015
Related to Application: gvSIG desktop - gvSIG bugs # 3118: Name descriptor du... Invalid 01/19/2015

Associated revisions
Revision 43356 - 07/01/2017 12:46 PM - Francisco Díaz Carsí

refs #3806 Sustituído el casting a Long de la oid por Number para poder obtener el valor de tipo long y pasarlo al método getFeatureProviderByIndex.

Revision 43371 - 07/10/2017 11:29 PM - Francisco Díaz Carsí

refs #3806 Fixed Spatial Join Algorithm

Revision 960 - 07/10/2017 11:29 PM - Francisco Díaz Carsí
refs #3806 Fixed Spatial Join Algorithm

Revision 961 - 07/18/2017 07:20 PM - Francisco Díaz Carsí

refs #3806 Deleted obsolete spatial index creation.

History
#1 - 10/07/2015 11:44 AM - Mario Carrera
- Related to gvSIG bugs #3013: Error con la herramienta spatialjoin added

#2 - 10/23/2015 12:01 PM - Álvaro Anguix
- Category set to Geoprocess

#3 - 11/02/2015 04:06 PM - Álvaro Anguix

Con gvSIG 2.3 da una capa vacía.

#4 - 11/02/2015 04:07 PM - Álvaro Anguix
- Severity changed from Minor to Major
- Target version set to 98
- Priority changed from Normal to High
- Assignee set to Daniel Martinez

#5 - 11/02/2015 04:08 PM - Álvaro Anguix
- Assignee deleted (Daniel Martinez)

#6 - 11/02/2015 04:14 PM - Álvaro Anguix
- Related to gvSIG bugs #3838: Random layers generated from the toolbox are not loaded in the view added

#7 - 01/18/2016 11:21 PM - Joaquín  del Cerro Murciano
- Target version deleted (98)

#8 - 06/26/2017 11:12 AM - Álvaro Anguix
- Related to gvSIG bugs #3566: enlace espacial no utiliza selección / spacialjoint does not use selecction added

#9 - 06/26/2017 11:13 AM - Álvaro Anguix
- Related to gvSIG bugs #3118: Name descriptor duplicated with gvSIG "Spatial Join" added

#10 - 06/28/2017 09:51 AM - Álvaro Anguix
- Target version set to 2.4.0-2850-final (rev. org.gvsig.desktop-2.0.220)

#11 - 07/01/2017 12:37 PM - Francisco Díaz Carsí
- File gvSIG.log added

En principio no puedo reproducir el error, porque salta un error antes.
Es un error de casting cogiendo el feature provider por referencia.

Adjunto log.
Una vez arreglado este error que subo relacionándolo con este tique, voy a ver si se puede solucionar el tema propio de éste.

#12 - 07/01/2017 02:58 PM - Francisco Díaz Carsí
- Status changed from New to Awaiting response

A ver, repasando lo que hace el algoritmo y lo que se pretende que haga el algoritmo de la descripción de este tique, creo que nos estamos
equivocando.

Tenemos dos capas, una de polígonos y otra de de puntos.
Seleccionamos la capa de polígonos como capa de entrada.
Selecionamos la capa de puntos como capa de "revestimiento".
Y marcamos el checkbox "Usar el más cercano".

Entonces, según la ayuda del propio algotimo, "Asigna a un elemento de la capa origen los atributos del elemento más próximo de la capa enlazada".
¿Qué entiendo que quiere decir esto?
Que el algoritmo debería devolver TODOS o los SELECCIONADOS de la capa de polígonos, añadiéndole los atributos de los elementos más
cercanos de la capa de puntos.
Hasta ahí considero que el algoritmo, si falla, no es precisamente por devolver demasiados elementos de la capa de polígonos, si no por no
delvolverlos todos (o su selección).
Si, en este momento no los devuelve todos, es por todas las restricciones que le hemos ido poniendo a la salida de este algoritmo capa vez que
revisitábamos este tique (u otros relacionados).

Si queremos un comportamiento distinto al que he descrito, habría que darle toda la vuelta al algoritmo.

A la espera de tomar una decisión al respecto, marco este tique como "Awaiting response".

#13 - 07/03/2017 08:31 AM - Álvaro Anguix
- File gvSIG.log added
- File Error_Spatial.png added
- File Capas.zip added

Perdón...el error que da es al contrario (revisando el texto de Mario).
La capa de entrada es la de puntos, imagina por ejemplo que son "delitos" 
La capa de revestimiento es de polígonos, imagina por ejemplo que son "barrios". En su tabla de atributos tiene una columna con el nombre del barrio
Queremos hacer un enlace espacial para saber el número de delitos por barrio, es decir, queremos que a la capa de puntos se le añada el campo con
el nombre del barrio.
Esto, al hacerlo, da error.

Subo 2 capas con el ejemplo que he puesto y el log. y la imagen de aviso de error.
Aunque igual no tiene nada que ver, con el geoproceso de enlace espacial de Sextante sí lo hace, pero el resultado que da es erróneo.

#14 - 07/10/2017 11:35 PM - Francisco Díaz Carsí
- Target version changed from 2.4.0-2850-final (rev. org.gvsig.desktop-2.0.220) to 2.4.0-2829 (rev. org.gvsig.desktop-2.0.195)
- Assignee set to Francisco Díaz Carsí
- Status changed from Awaiting response to Fixed
- Description updated

#15 - 07/26/2017 08:14 AM - Álvaro Anguix
- Status changed from Fixed to Closed

Files
spatial-join.zip 9.84 MB 10/07/2015 Mario Carrera
gvSIG.log 401 KB 07/01/2017 Francisco Díaz Carsí
Capas.zip 224 KB 07/03/2017 Álvaro Anguix
Error_Spatial.png 62.8 KB 07/03/2017 Álvaro Anguix
gvSIG.log 403 KB 07/03/2017 Álvaro Anguix
